//////////////////////////////////////////////////////////////////////////////////////////////
// EvalObjFun.cpp 
// The file defines the function EvalObjFun. 
// The function EvalObjFun computes rp.BFR for both young and aged animals. 
// This function is called by the file main.cpp. 
// Created by Jitendra Prasad, Ph.D. / Brandon J. Ausk / Sundar Srinivasan, Ph.D.
// University of Washington at Seattle. 
//////////////////////////////////////////////////////////////////////////////////////////////

#include <vector>
using namespace std;

#include "Iterate.h"

double EvalObjFun(int nABM, vector<double> Para, float Tcmin,  
				  vector<vector<double> > Prot_young, int nProt_young, double extratime, 
				  vector<double> prottime_young, vector<double> maxtime_young,
				  int nob_young, int ncell_young, 
				  vector<vector<int> > agentConnection_young, vector<int> agentcount_young, 
				  vector<int> dummyagentcount_young, vector<vector<double> > strain_young, 
				  vector<vector<double> > Prot_aged, int nProt_aged,  
				  vector<double> prottime_aged, vector<double> maxtime_aged,
				  int nob_aged, int ncell_aged, 
				  vector<vector<int> > agentConnection_aged, vector<int> agentcount_aged, 
				  vector<int> dummyagentcount_aged, vector<vector<double> > strain_aged,
				  vector< vector<double> > BFRinVivo_combined, vector<double> std_combined)
{
	int nABM_young = nABM/2;
	vector<double> ParaVec(nABM_young,0);
	vector< vector<double> > ParaList_young(1,ParaVec);
	int nPara_young = 1;
	for(int j=0; j<nABM_young; j++)
		ParaList_young[0][j] = Para[j];
	
	//Iterate for every parameter and protocol
	
	vector<vector<double> > rpBFR_Para_young = DoIterations(Tcmin, ParaList_young, nPara_young, nABM_young, 
															Prot_young, nProt_young, extratime, 
															prottime_young, maxtime_young,
															nob_young, ncell_young, 
															agentConnection_young, agentcount_young, 
															dummyagentcount_young, strain_young, true);
															
	//Repeat for old mice
	int nABM_aged = nABM_young;
	vector< vector<double> > ParaList_aged(1,ParaVec);
	int nPara_aged = 1;
	for(int j=0; j<nABM_aged; j++)
		ParaList_aged[0][j] = Para[nABM/2+j];
	
	vector<vector<double> > rpBFR_Para_aged = DoIterations(Tcmin, ParaList_aged, nPara_aged, nABM_aged, 
														   Prot_aged, nProt_aged, extratime, 
														   prottime_aged, maxtime_aged,
														   nob_aged, ncell_aged, 
														   agentConnection_aged, agentcount_aged, 
														   dummyagentcount_aged, strain_aged, false);
	return 1;
}