//////////////////////////////////////////////////////////////////////////////////////////////
// Input.cpp
// The file defines the function ReadDoubleMatrix.
// The function ReadDoubleMatrix reads a data file and stores it in a matrix form.
// This function is called by main.cpp. 
// Created by Jitendra Prasad, Ph.D. / Brandon J. Ausk / Sundar Srinivasan, Ph.D.
// University of Washington at Seattle. 
//////////////////////////////////////////////////////////////////////////////////////////////

#include <vector>
#include <fstream>
#include <string>
#include <sstream>
using namespace std;

vector<vector<double> > ReadDoubleMatrix(const char* filename)
{
   vector < vector < double > > info;
   ifstream file(filename);
   string line;
   while ( getline(file, line) )
   {
      vector < double > data;
      double value;
      istringstream iss(line);
      while (iss >> value)
      {
         data.push_back(value);
      }
      info.push_back(data);
   }
   file.close(); 
   return info;
}

vector<double> ReadDoubleVector(const char* filename)
{

	vector < double > data;
   ifstream file(filename);
   string line;
   while ( getline(file, line) )
   {
      double value;
      istringstream iss(line);
      while (iss >> value)
      {
         data.push_back(value);
      }

   }
   file.close(); 
   return data;
}
