//////////////////////////////////////////////////////////////////////////////////////////////
// Output.cpp
// The file defines the function OutputToFile.
// The function OutputToFile outputs data to a file.
// This function is called by Iterate.cpp. 
// Created by Jitendra Prasad, Ph.D. / Brandon J. Ausk / Sundar Srinivasan, Ph.D.
// University of Washington at Seattle. 
//////////////////////////////////////////////////////////////////////////////////////////////

#include <string>
#include <sstream>
#include <fstream>
#include <vector>
using namespace std;

void OutputToFile(string DataType, bool IsYoung, int ProtNum, vector< vector<double> > Data, string RowData, string ColumnData)
{
	string filename(DataType);
	if(IsYoung == true)
		filename.append("_Young_");
	else
		filename.append("_Aged_");
	
	if (ProtNum >= 0)
	{
		filename.append("Prot_");
		stringstream ss;
		ss << ProtNum+1;
		filename.append(ss.str());
	}
	
	filename.append(".txt");
	char * cstr;
	cstr = new char [filename.size()+1];
	strcpy (cstr, filename.c_str());
	
	ofstream outfile(cstr);
	//outfile << DataType << " : " << RowData << " in Rows; " << ColumnData << " in Columns." << endl;
	int FieldWidth = 10;
	//outfile.width(FieldWidth);
	//outfile.precision(10);
	//outfile << RowData << " ";
	//outfile << DataType << " ";
	int nRow = Data.size();
	int nColumn = Data[0].size();
	if(ProtNum >= -1)
	{
		int nob = nColumn;
		
		//	for(int i=nob/2; i<nob; i++)
		//	{
		//		outfile.width(FieldWidth);
		//		outfile << i+1 << " ";
		//	}
		//	outfile << endl;
		
		int endtime = nRow;
		for(int t = 0; t < endtime; t++)
		{
			outfile.width(FieldWidth);
			if(ProtNum == -1)
				outfile << t+1 << " ";
			else
				outfile << t << " ";
			for(int i=nob/2; i<nob; i++)
			{
				//outfile.precision(2);
				outfile.width(FieldWidth);
				outfile << Data[t][i] << " ";
			}
			outfile << endl;
		}
	}
	else
	{
		int nProt = nColumn;
		outfile.width(FieldWidth);
		outfile << "Protocol" << " ";
		outfile.width(FieldWidth);
		outfile << DataType << " ";
		outfile << endl;
		
		for(int i=0; i<nProt; i++)
		{
			outfile.width(FieldWidth);
			outfile << i+1 << " ";
			//}
			//outfile << endl;
			int nParam = nRow;
			for(int j = 0; j < nParam; j++)
			{
				//outfile.width(FieldWidth);
				//outfile << j+1 << " ";
				//for(int i=0; i<nProt; i++)
				//{
				outfile.width(FieldWidth);
				outfile << Data[j][i] << " ";
				//}
				outfile << endl;
			}
		}
	}
	outfile.close();
}
